#include <cstdio>
#include <cmath>
#include <vector>
#include <queue>

#define NMAX 1205
#define INF 0x3f3f3f3f

using namespace std;

int n;
bool viz[NMAX];
double d[NMAX];
double cost[NMAX][NMAX];

struct oras
{
    double x,y;
} o[NMAX];

inline double dist(int i,int j)
{
    return sqrt((o[i].x-o[j].x)*(o[i].x-o[j].x)+(o[i].y-o[j].y)*(o[i].y-o[j].y));
}

void read()
{
    scanf("%d",&n);
    for(int i=1;i<=n;++i)
    {
        scanf("%lf%lf",&o[i].x,&o[i].y);
        for(int j=1;j<i;++j)
            cost[i][j]=cost[j][i]=dist(i,j);
    }
}

void solve()
{
    int k;
    d[1]=0;
    for(int i=2;i<=n;++i)
        d[i]=INF;
    priority_queue<pair<double,int> > h;
    h.push(make_pair(0,1));
    while(!h.empty())
    {
        k=h.top().second;
        h.pop();
        viz[k]=1;
        for(int i=1;i<=n;++i)
            if(!viz[i]&&d[i]>cost[k][i])
            {
                d[i]=cost[k][i];
                h.push(make_pair(-cost[k][i],i));
            }
    }
    double Ans=0;
    for(int i=2;i<=n;++i)
        Ans+=d[i];
    printf("%lf",Ans);
}

int main()
{
    freopen("curent.in","r",stdin);
    freopen("curent.out","w",stdout);
    read();
    solve();
    return 0;
}
