/// INELUS Gabriel Robert
#include <cstdio>
#include <vector>

#define Nmax 160
#define Gmax 30000

using namespace std;
int w[Nmax],N; /// w[i] = a i a greutate
int used[Nmax];/// used[i] =1/0 daca primul copil a luat cadoul asta
int DP[Gmax]; /// DP[i] = 1/0 daca se poate atinge sau nu acea greutate
int tata[Gmax]; /// tata[i] = indicele greutatii folosite sa ajungem in starea i ( sa avem greutatea i )

int G; /// suma greutatilor
vector<int>sol1,sol2;

void Read()
{
    scanf("%d",&N);
    for(int i = 1; i <= N; ++i)
    {
        scanf("%d",&w[i]);
        G += w[i];
    }
}

int diferenta(int k)
{
    int v1,v2;
    v1 = k;
    v2 = G - k;
    if(v1 > v2)///returnam valoarea absoluta
        return v1 - v2;
    return v2 - v1;
}

void afish_dif(int k)
{
    int v1,v2;
    v1 = k;/// v1 are greutatea k
    v2 = G-k; /// v2 are G-k
    printf("%d %d\n",v1,v2);
}

void Dynamic()
{
    DP[0] = 1;/// se poate atinge greutatea 0 ne punand nimik
    int Gcrt = 0;
    for(int i = 1; i <= N; ++i)
    {
        Gcrt += w[i]; /// optimizam punctul de start
                     /// pt ca nu pot obtine folosind primele i greutati mai mult decat cantaresc ele
        for(int j = Gcrt; j >= w[i]; --j)
            if(DP[j] == 0 && DP[j - w[i]] == 1)
            {
                DP[j] = 1; /// pot obtine greutatea j si nu am mai fost in greutatea asta
                tata[j] = i; /// folosind greutatea a i-a am ajuns in starea j
            }
    }
    int mij = G / 2;
    int jos,sus,start1;
    for(int i = mij; i >= 0; --i)
        if(DP[i] == 1){ /// caut la stanga mijlocului prima greutate atinsa
            jos = i;
            break;
        }
    for(int i = mij; i <= G; ++i)
        if(DP[i] == 1){ /// caut la dreapta mijlocului prima greutate atinsa
            sus = i;
            break;
        }
    if(diferenta(jos) <= diferenta(sus)) /// vedem care este diferenta optima dorita
        start1 = jos; /// daca primul alege jos-ul vom obtine diferenta minima
    else
        start1 = sus; /// daca primul alege limita de sus vom obtine diferenta minima

    afish_dif(start1);

    while(tata[start1]){ /// cat timp bagam o greutate
        sol1.push_back(w[tata[start1]]); /// formam solutia 1
        used[tata[start1]] = 1; /// marcam indicele greutatii ca fiind folosit
        start1 -= w[tata[start1]]; /// scadem greutatea curenta
    }
    for(int i = 1; i <= N; ++i)
        if(!used[i]) /// toate greutatile nefolosite de primul sunt folosite de al 2 lea
            sol2.push_back(w[i]);
}

void Print()
{
    for(vector<int>::iterator it = sol1.begin(); it != sol1.end(); ++it)
        printf("%d ",*it);
    printf("\n");
    for(vector<int>::iterator it = sol2.begin(); it != sol2.end(); ++it)
        printf("%d ",*it);
    printf("\n");

}

int main()
{
    freopen("cadou.in","r",stdin);
    freopen("cadou.out","w",stdout);

    Read();
    Dynamic();
    Print();

    return 0;
}
